// UserMemory.h: interface for the CUserMemory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_USERMEMORY_H__AB506C4A_10BF_44B6_BC3D_A45E800B5842__INCLUDED_)
#define AFX_USERMEMORY_H__AB506C4A_10BF_44B6_BC3D_A45E800B5842__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define MAX_BUFFER_SIZE			(1L<<20)
#define NOTIFYBUFFER_SIZE		0x4000   //10K

#define DRIVER_EVENT_NAME L"\\BaseNamedObjects\\Semaphore{2956497D-A685-433e-9F25-267FA3B0E715}"




typedef struct _NOTIFYBUFFER
{
	long count;							// Amount of data currently in buffer
	long write;							// write count - this increments but is never reset
	long read;							// read point - this is only changed by sysman
	long size;							// how many entries? This equals RINGBUFFER_ENTRIES and never changes
	char buffer[NOTIFYBUFFER_SIZE];		// Our actual entries

} NOTIFYBUFFER;

typedef struct _SHARED_BUFFER
{
	unsigned long		ulSig;			// 0xbeefdead
	NOTIFYBUFFER		notify_buffer;

} SHARED_BUFFER, *PSHARED_BUFFER;




class CUserMemory  
{
	SAFE_DESTRUCTORS;
public:
	static CUserMemory* Instance();
	static void Cleanup();
	~CUserMemory();

	PVOID MapToUserSpace();
	void  Unmap (PVOID);

	inline ULONG GetSize() { return MAX_BUFFER_SIZE;}

	PVOID GetKernelPtr(){return m_pBuffer;
	}
	static bool WriteToRingBuffer( NOTIFYBUFFER & ring_buffer, char * data, int datasize );

	void NotifyWrite();

private:


	CUserMemory();
	static CUserMemory* m_pInstance;

	PVOID		m_pBuffer;
	KMemory	* 	m_pMdl;
	KEvent  *	m_pNotifyEvent;
};

struct MemoryResult
{
	PVOID m_ret;
	ULONG m_size;
};

#endif // !defined(AFX_USERMEMORY_H__AB506C4A_10BF_44B6_BC3D_A45E800B5842__INCLUDED_)
